#include "LLL.h"
extern int numberofvektors;

double lensq(vektor_f *a)
{
	vektor_f A1=(*a* *a);
	return A1.sum();
}

int down(double f)
{
	if(f>=0)return int(f);
	return int(f-1);
}

void calcmy(basis_i b, basis_f &my, vektor_f &B)
{
  basis_f bs=tobasis_f(b);

  for(int k=0;k<b.size();k++)
    {
      bs[k]=b[k];
      for(int j=0;j<k;j++)
	{
	  if(B[j]==0)
	    my[k][j]=0;
	  else
	    my[k][j]=dot(vektor<double>(b[k]),bs[j])/B[j];
	  
	  bs[k]=bs[k]-my[k][j]*bs[j];
	}
      B[k]=dot(bs[k],bs[k]);
    }
}

void calclambda(basis_i b, basis_f &lambda /*,vektor_f &B*/)
{
  for(int k=0;k<b.size();k++)
    {
      for(int j=0;j<=k;j++)
	{
	  double u=dot(b[k],b[j]);
			
	  for(int i=0;i<j;i++)
	    {
	      if(i-1==-1)
		{
		  u=lambda[i][i]*u-lambda[k][i]*lambda[j][i];
		}
	      else
		{
		  if(lambda[i-1][i-1]!=0)
		    {
		      u=lambda[i][i]*u-lambda[k][i]*lambda[j][i];
		      u/=lambda[i-1][i-1];
		    }
		}
	    }
	  lambda[k][j]=u;
	}
    }
}

basis_i	mlll(basis_i &b)
{
  int k=1;
  int n=b.size();

  basis_f my(n);
  for(int p=0;p<n;p++)my[p].resize(n);
  basis_f lambda=my;
  vektor_f B(n);
  basis_i M(n);
  for(int p=0;p<n;p++)M[p].resize(n);
  {
    for(int i=0;i<n;i++)
      for(int j=0;j<n;j++)M[i][j]=0;
    for(int i=0;i<n;i++)M[i][i]=1;
  }
	
  while(k<n)
    {
      for(int l=k-1;l>=0;l--)
	{	//size reduction
	  calcmy(b,my,B);
	  calclambda(b,lambda);
	  int q=down(my[k][l]+0.5);
	  if(q)
	    {

	      b[k]=b[k]-q*b[l];
	      M[k]=M[k]-q*M[l];
	    }
	}
      calcmy(b,my,B);
      calclambda(b,lambda);
      //test Lovasz' condition
      if(B[k]<(0.75-my[k][k-1]*my[k][k-1])*B[k-1])
	{
	  vektor_f temp=b[k];b[k]=b[k-1];b[k-1]=temp;
	  vektor_f temp1=M[k];M[k]=M[k-1];M[k-1]=temp1;
	  k--;
	  if(k<1)k=1;
	}
      else k++;
    }

  return M;
}
