#include "flip.h"
#include <stdio.h>
#include <stdlib.h>
#include <set.h>
#include "lp.h"
#include "radical.h"

#include "main.h"

//bool gfanprinton;
bool useordered;
FILE *flip_listfile;

static void foreachvertex(const gbasis &g)
{
  static int n;

  switch(option_vertexprinting)
    {
    case 1:
      print_tigers(g,n,flip_listfile);
      break;
    case 1+128:
      if(n)fprintf(flip_listfile,",\n");
      print_tigers_strip(g,n,flip_listfile);
      break;
    case 2:
      print_tigers_in(g,n,flip_listfile);
      break;
    case 2+128:
      if(n)fprintf(flip_listfile,",\n");
      print_tigers_in_strip(g,n,flip_listfile);
      break;
    case 3:
      fprintf(flip_listfile,"$G_{%i}=\\{$ ",n);
      printt(g,flip_listfile);
      fprintf(flip_listfile," $\\}$\n\n",n);
      //     printf("\\vspace{0.5cm}");
      break;
    case 0:
    default:
      break;
    }
  n++;
}


bool vektorcmp2(const vektor_i& a, const vektor_i& b)
{
  //  if(a.size()!=b.size())return false;
  for(int i=0;i<a.size();i++)
    {
      if(a[i]<b[i])return true;
      if(a[i]>b[i])return false;
    }
  return false;
}

bool gbcmp::operator()(const gbasis& a,const gbasis& b) const
{
  gbasis::const_iterator i=a.begin();
  gbasis::const_iterator j=b.begin();

  while((i!=a.end())&&(j!=b.end()))
    {
      if(vektorcmp2(*i,*j))return true;
      if(vektorcmp2(*j,*i))return false;

      i++;
      j++;
    }
  if(i!=a.end())return false;
  if(j!=b.end())return true;

  return false;
}


static void buchberger_(gbasis &spolys, vektor_i a)
{
  gbasis final;
  int totalspolys=0;
  vektor_i w=a;

  //  fprintf(stderr,"starting buchberger_\n");

  a.calcsupport();  // SUPPORT!!

  while(!spolys.empty())
    {
      vektor_i v=*spolys.begin();

      v.calcsupport();//SUPPORT!!

      totalspolys++;
      spolys.pop_front();
      {
	for(gbasis::const_iterator i=final.begin();i!=final.end();++i)
	  {
	    if(((i->support)&(~v.support))==0)
	      if(i->divides(v))goto next;
	  }
	//	while(a.lt().divides(v)){v=v-a;v.calcsupport();}//SUPPORT!!
	while(a.divides(v)){v-=a;}
	v.calcsupport();//SUPPORT!!
	for(gbasis::const_iterator i=final.begin();i!=final.end();++i)
	  {
	    if(((i->support)&(~v.support))==0)
	      if(i->divides(v))goto next;
	  }
      }
      
      if(!v.iszero())
	{
	  for(int i=0;i<w.size();i++)w[i]=max(max(a[i],0),v[i])-a[i];
	  w.calcsupport();//SUPPORT!!!
	  spolys.push_back(w);

	  v.calcsupport();
	  final.push_back(v);
	}
    next:;
    }

  // compute the minimal (and reduced!) basis

  for(gbasis::iterator i=final.begin();i!=final.end();i++)
    {
      bool e=true;
      for(gbasis::iterator j=final.begin();j!=final.end();j++)
	{
	  if(j!=i)
	    if(((j->support)&(~i->support))==0)
	      if(j->divides(*i)){e=false;break;}
	}
      if(e)spolys.push_back(*i);
    }
  //      spolys=final;
  //  fprintf(stderr,"ending buchberger_\n");

}

static int iszero(vektor_i v)
{
  for(int i=0;i<v.size();i++)if(v[i])return 0;
  return 1;
}

gbasis flip(const gbasis& g, const vektor_i& p)
{
  gbasis nevv;
  gbasis gm;

  //compute the monomials in new:
  for(gbasis::const_iterator i=g.begin();i!=g.end();++i)
    {
      if(iszero(*i-p))
	;//nevv.push_back(-p);
      else
	nevv.push_back(i->lt());
    }

  //compute basis for the initial ideal wrt other termorder
  buchberger_(nevv,-p);

  //the inverse to the flip binomial is in the new basis
  gm.push_back(-p);
	gm.back().calcsupport();//!!!!!support

  //nevv only contains monomials
  for(gbasis::const_iterator i=nevv.begin();i!=nevv.end();++i)
    if(iszero(*i-i->lt()))
      {
	vektor_i v=*i;

	v.calcsupport();//SUPPORT!!

	division_(&v,g);

	gm.push_back(*i-v);
	gm.back().calcsupport();//!!!!!support
      }
  return gm;
}

bool preirredundant(const gbasis &g, const gbasis::const_iterator &i)
{
  bool facet=true;
	  vektor_i s(i->size());
  for(gbasis::const_iterator j=g.begin();j!=g.end();j++)
    {
      bool inideal=false;
      if(i!=j)
	{
	  for(int k=0;k<s.size();k++)s[k]=max(max((*i)[k],0),(*j)[k])-(*i)[k];
	  s.calcsupport();

	  for(gbasis::const_iterator l=g.begin();l!=g.end();l++)
	    if(((l->support)&(~s.support))==0)
	      if(l->divides(s))
		{
		  inideal=true;
		  break;
		}
	  if(!inideal)
	    {
	      facet=false;
	      break;
	    }
	}
    }
  return facet;
}

gbasis irredundant(const gbasis &g)
{
  gbasis temp;


  if(option_facetsuperset)
    {
      for(gbasis::const_iterator i=g.begin();i!=g.end();i++)
	{
	  if(preirredundant(g,i))temp.push_back(*i);
	}
    }
  else
    {
      temp=g;
    }

  //  fprintf(stderr,"A:%i B:%i\n",g.size(),temp.size());


  gbasis r;

  for(gbasis::const_iterator i=temp.begin();i!=temp.end();i++)
    {
      if(isfacet(temp,i))
	 r.push_back(*i);
    }
  return r;
}

bool vektorcmp(const vektor_i& a, const vektor_i& b)
{
  if(a.size()!=b.size())return false;
  for(int i=0;i<a.size();i++)
    {
      if(a[i]!=b[i])return false;
    }
  return true;
}

bool gbasiscmp(const gbasis& a,const gbasis& b)
{
  gbasis::const_iterator i=a.begin();
  gbasis::const_iterator j=b.begin();

  while((i!=a.end())&&(j!=b.end()))
    {
      if(!vektorcmp(*i,*j))return false;

      i++;
      j++;
    }

  if((i==a.end())&&(j==b.end()))return true;

  return false;
}

bool gfanmember(const gbasis& b, gfan f)
{
  for(gfan::const_iterator i=f.begin();i!=f.end();i++)
    {
      if(gbasiscmp(*i,b))return true;
    }
  return false;
}

static bool ismember(const vektor_i &p, const gbasis &b)
{
  for(gbasis::const_iterator i=b.begin();i!=b.end();i++)
    {
      vektor_i a=*i-p;
      if(a.iszero())return true;
    }
  return false;
}

static int getindex(const gbasis &b, const gfan &f)
{
  int index=0;

  for(gfan::const_iterator i=f.begin();i!=f.end();i++)
    {
      if(gbasiscmp(*i,b))return index;
      index++;
    }
  return index;
}

static void printt3(const vektor_i &v, FILE *f=stdout)
{
  bool a=v.ordered();

  print_math(f);
  if(a)fprintf(f,"\\underline{");
  printmono(v,1,f);
  if(a)fprintf(f,"}");
  fprintf(f,"-");
  if(!a)fprintf(f,"\\underline{");
  printmono(v,-1,f);
  if(!a)fprintf(f,"}");
  print_math(f);
  fprintf(f,"\n\n");
}


bool lexicographiccmp(vektor_i v)
{
  int n=v.size();
  for(int i=0;i<n;i++)
    {
      int index=i;
      if(v[index]<0)return 0;
      if(v[index]>0)return 1;
    }
  return 1;
}

void printt3(const gbasis &b, const gfan &gf, FILE *f=stdout)
{
  gbasis irr=irredundant(b);
  int best=-1;
  const vektor_i *bestref;
  int ind=0;
  

  for(gbasis::const_iterator i=b.begin();i!=b.end();i++)
    {
      if(ismember(*i,irr))
	{
	  if(!i->ordered())
	    {
	      if(best==-1)
		{
		  best=ind;
		  bestref=&(*i);
		}
	      else
		{
		  vektor_i a=*i;
		  vektor_i b=*bestref;
		  
		  //		  a.order();
		  //		  b.order();
		  
		  //		  if(lexicographiccmp(b.lt()-a.lt()))
		  if(lexicographiccmp(a.lt()-b.lt())) //rettet 18.april
		    {
		      best=ind;
		      bestref=&(*i);
		    }
		}
	    }
	}
      ind++;
    }

  ind=0;

  for(gbasis::const_iterator i=b.begin();i!=b.end();i++)
    {
      if(!ismember(*i,irr))
	{
	  printt3(*i);
	}
      else
	{
	  gbasis beta=flip(b,*i);
	  //	  printf("resultat af flip:\n\n");printt(beta);
	  gbasisminimal(&beta);
	  gbasisautoreduction(&beta);
	  gbasissort(&beta);

	  int index=getindex(beta,gf);

	  if(ind==best)printf("\\fbox{");
	  printf("\\fbox{");
	  printt3(*i);
	  if(ind==best)printf("}");
	  printf("}$_{%i}$\n\n",index);
	}
      ind++;
    }
}

void gfanprint(const gfan &B)
{
  {
    int j=0;
    for(gfan::const_iterator i=B.begin();i!=B.end();i++)
      {
	printf("\\fbox{\n");
	printf("Basis no. %i\n\n",j);
	printt3(*i,B);     
	printf("}\n\n");
	if(0)
	  {
	    printf("\\fbox{\n");
	    printf("Radical %i\n\n",j);
	    printinitial(initialradical(*i));     
	    printf("}\n\n");
	  }
	j++;
      }
  }
}

int computegrobnerfan_size;
int computegrobnerfan_nedges;

void computegrobnerfan(gbasis &g)
{
  int nflips=0;
  gfan2 A,B;
  int Asize=0;

  gbasissort(&g);
  A.insert(g);
  Asize++;
  B.insert(g);

  while(A.size()>0)
    {
      gbasis b=*A.begin();
      foreachvertex(b);

      A.erase(A.begin());
      Asize--;

  for(gbasis::iterator i=b.begin();i!=b.end();i++)i->calcsupport();
      gbasis irr=irredundant(b);
      {
	static int i;
	i++;
	if(!(i&255))
	  fprintf(stderr,"Number of active vertices:%i. Number of faces for current vertex:%i. Current number of Gr\"obner bases: %i\n",Asize,irr.size(),B.size());
      }
      for(gbasis::const_iterator i=irr.begin();i!=irr.end();i++)
	if((!useordered)||(i->ordered()))
	{
	  gbasis beta=flip(b,*i);
	  nflips++;
	  gbasisminimal(&beta);
	  gbasisautoreduction(&beta);
	  gbasissort(&beta);
	  if(B.count(beta)==0)
	    {
	      A.insert(beta);
	      Asize++;
	      B.insert(beta);
	    }
	}
    }

  computegrobnerfan_size=B.size();
  computegrobnerfan_nedges=nflips;
  if(!useordered)computegrobnerfan_nedges/=2;

  if(option_detailedprinting)
    //  if(gfanprinton)
  {
  //      vektor_i::TERMORDER=REVERSELEXICOGRAPHIC;
  //      vektor_i::setcheapest(0);

    //print the Gr\"obner fan
    gfan B2(0);
    for(gfan2::iterator i=B.begin();i!=B.end();i++)
      {
	B2.push_back(*i);
      }
    gfanprint(B2);
    printradicals(B2);
  }
  

  fprintf(stderr,"Number of flips:%i\n",nflips);
}

gbasis walk(gbasis &g) //ny version 22 juni 2002
{
 loop:
  {
    gbasis temp;
    
    for(gbasis::const_iterator i=g.begin();i!=g.end();i++)
      {
	if(preirredundant(g,i))temp.push_back(*i);
      }
    
    for(gbasis::const_iterator i=temp.begin();i!=temp.end();i++)
      {
	if(!(i->ordered()))if(isfacet(temp,i))
	  {
	    fprintf(stderr,"flipping!\n");
	    g=flip(g,*i);
	    printf("\nFlip to basis with %i elements.\n\n",g.size());
	    print_time();
	    //	printt(g);
	    fflush(stdout);
	    goto loop;//i=g.begin();
	  }
      }
  }
  return g;
}

inline static bool treesize_cmp(vektor_i& a, vektor_i& b)
{
  int n=a.size();
  for(int i=0;i<n;i++)
    {
	  if(a.lt()[i]>b.lt()[i])return true;
	  if(a.lt()[i]<b.lt()[i])return false;
    }
  return false;
}

inline static bool isoutgoingold(gbasis &h, vektor_i &mi)
{
  gbasis irr2=irredundant(h);
  for(gbasis::iterator j=irr2.begin();j!=irr2.end();j++)
    if(!j->ordered())
      if(treesize_cmp(*j,mi))return false;
  return true;
}

class ltcmp
{//noedvendigt at lave ny cmp funktion! den gamle sammenlignede ikke kun lt
public:
bool operator()(const vektor_i& a,const vektor_i& b) const
{
  return a.lt()<b.lt();
}
};

ltcmp ltcmp2;

inline static bool isoutgoing(gbasis &h, vektor_i &mi)
{
  //  gbasissort(&h);

  h.sort(ltcmp2); //alligevel ikke fjernet 17. maj 2002

  for(gbasis::iterator j=h.begin();j!=h.end();j++)
    {
      if(!j->ordered())
	{
	  if(iszero(mi-*j))return true;
	  if((option_facetsuperset==0)||preirredundant(h,j))
	    if(isfacet(h,j))return false;
	}
    }
  assert(0);
  return false;
}

static int treesize(gbasis &g)
{
  int ts=1;
  foreachvertex(g);

  {
    static int ts2=0;
    ts2++;
    if(!(ts2&255))fprintf(stderr,"%i\n",ts2);
    fflush(stderr);
  }


  gbasis irr=irredundant(g);

  for(gbasis::iterator i=irr.begin();i!=irr.end();i++)
    if(i->ordered())
      {
	bool largest=true;
	computegrobnerfan_nedges++;
	gbasis h=flip(g,*i);
	  gbasisautoreduction(&h);
	vektor_i mi=-*i;
	if(isoutgoing(h,mi))ts+=treesize(h);
      }
  return ts;
}

void computegrobnerfan_rs(gbasis &g)
{
  //      vektor_i::TERMORDER=REVERSELEXICOGRAPHIC;
  //      vektor_i::setcheapest(0);

  computegrobnerfan_nedges=0;
  computegrobnerfan_size=treesize(g);
}



struct it;

it *new_it();
void delete_it(it*);

typedef struct pgb
{
  gbasis gb;
  int priority;
  gbasis outedges;
  it *i;
  //  pgbqueue::iterator i;
  pgb():gb(),outedges()
  {
    i=new_it();
  }
  ~pgb()
  {
    delete_it(i);
  }

  void computefacets()
  {
    gbasis irr=irredundant(gb);
    for(gbasis::const_iterator i=irr.begin();i!=irr.end();i++)
      {
	if(i->ordered())
	  {
	    outedges.push_back(*i);
	  }
	else
	  {
	    priority++;
	  }
      }
    //    fprintf(stderr,"computed priority:%i\n",priority);
  }
}pgb;

struct hbgbcmp1
{
  //bool operator()(const pgb* &a,const pgb* &b) const
bool operator()(pgb* const &a,pgb* const &b) const
{
  gbasis::const_iterator i=a->gb.begin();
  gbasis::const_iterator j=b->gb.begin();

  while((i!=a->gb.end())&&(j!=b->gb.end()))
    {
      if(vektorcmp2(*i,*j))return true;
      if(vektorcmp2(*j,*i))return false;

      i++;
      j++;
    }
  if(i!=a->gb.end())return false;
  if(j!=b->gb.end())return true;

  return false;
}
};

struct hbgbcmp2
{
bool operator()(pgb* const &a, pgb* const &b) const
{
  if(a->priority<b->priority)return true;
  if(a->priority>b->priority)return false;
  gbasis::const_iterator i=a->gb.begin();
  gbasis::const_iterator j=b->gb.begin();

  while((i!=a->gb.end())&&(j!=b->gb.end()))
    {
      if(vektorcmp2(*i,*j))return true;
      if(vektorcmp2(*j,*i))return false;

      i++;
      j++;
    }
  if(i!=a->gb.end())return false;
  if(j!=b->gb.end())return true;

  return false;
}
};

typedef set<pgb*,hbgbcmp1> pgbset;
typedef set<pgb*,hbgbcmp2> pgbqueue;

struct it
{
  pgbqueue::iterator i;
};

it* new_it()
{
  return new it;
}

void delete_it(it* i)
{
  delete i;
}

void computegrobnerfan_hb(gbasis &g)
{
  int fansize=0;
  pgbset s;
  pgbqueue q;

  gbasisminimal(&g);
  gbasisautoreduction(&g);
  gbasissort(&g);


  pgb *a=new pgb;
  pgb *temppgb=new pgb;

  a->gb=g;
  a->priority=0;
  a->computefacets();

  s.insert(a);
  a->i->i=q.insert(q.begin(),a);

  while(!q.empty())
    {
      {
	static int v;
	v++;
	if(!(v&255))
	fprintf(stderr,"fansize: %i\n",fansize);
      }
      fansize++;
      a=*q.begin();
      foreachvertex(a->gb);
      q.erase(q.begin());
      s.erase(s.find(a));

      assert(a->priority==0);
      for(gbasis::const_iterator i=a->outedges.begin();i!=a->outedges.end();i++)
	{
	    {
	      gbasis temp=flip(a->gb,*i);
	      gbasisminimal(&temp);
	      gbasisautoreduction(&temp);
	      gbasissort(&temp);

	      temppgb->gb=temp;
	      if(s.end()==s.find(temppgb))
		{
		  pgb *b=new pgb;
		  b->gb=temp;

		  b->priority=-1;
		  b->computefacets();
		  
		  s.insert(b);
		  b->i->i=q.insert(q.begin(),b);
		}
	      else
		{
		  pgbset::iterator j=s.find(temppgb);
		  q.erase((*j)->i->i);
		  (*j)->priority--;
		  (*j)->i->i=q.insert(q.begin(),*j);
		}
	    }	  
	}
      delete a;
    }
  computegrobnerfan_size=fansize;
  delete temppgb;
}
















