#pragma ident "@(#) $Id: example.cpp,v 1.39 2002/04/06 13:05:02 bzfkocht Exp $"

#include "lp.h"
#include "Rsimp.h"
#include "print.h"

#include <assert.h>
#include <math.h>
#include <string.h>
#include <iostream>
#include <iomanip>
#include <fstream>

#ifdef SOPLEX
#include "spxdefines.h"
#include "spxsolver.h"

#include "timer.h"
#include "spxpricer.h"
#include "spxdefaultpr.h"
#include "spxparmultpr.h"
#include "spxdevexpr.h"
#include "spxhybridpr.h"
#include "spxsteeppr.h"
#include "spxweightpr.h"
#include "spxratiotester.h"
#include "spxharrisrt.h"
#include "spxdefaultrt.h"
#include "spxfastrt.h"
#include "spxsimplifier.h"
#include "spxaggregatesm.h"
#include "spxredundantsm.h"
#include "spxrem1sm.h"
#include "spxgeneralsm.h"
#include "spxscaler.h"
#include "spxequilisc.h"
#include "spxsumst.h"
#include "spxweightst.h"
#include "spxvectorst.h"
#include "slufactor.h"
#endif

#include "main.h"

#ifdef SOPLEX
using namespace soplex;
#endif

int lp_status=0;

bool lp_soplexlinked=
#ifdef SOPLEX
true
#else
false
#endif
;
static int isirredundant_huberthomas(const gbasis &g, gbasis::const_iterator i)
{//returns true if facet binomial
      bool found1,found=false;

      {
	#define M_ 40
	#define N_ 1000
	int ret;
	int n,m;
	static double A_[N_][M_];
	static double *A[N_];
	static double R_[N_][M_];
	static double *R[N_];
	static double Q_[N_][M_];
	static double *Q[N_];
	static double b[M_];
	static double c[N_];
	static double x[N_];
	static int basis[M_];
	static int nonbasis[N_];
	static double t1[M_+N_];
	static double t2[M_+N_];


	int D=i->size();
	int M=g.size();

	// hjde m
	// bredde n

      
       
	//m=i->size();
	//n=m+2*g.size();

	assert(D<=M_);
	assert(D+2*M<=N_);

	for(int j=0;j<D+2*M;j++)A[j]=&(A_[j][0]);
	for(int j=0;j<D+2*M;j++)R[j]=&(R_[j][0]);
	for(int j=0;j<D+2*M;j++)Q[j]=&(Q_[j][0]);
	int idx=0;
	for(gbasis::const_iterator j=g.begin();j!=g.end();j++)
	  {
	    for(int row=0;row<D;row++)
	      A_[row][idx]=j->v[row];
	    if(j==i)
	      for(int row=0;row<D;row++)
		A_[row][idx]*=-1;
	    for(int row=D;row<D+2*M;row++)
	      A_[row][idx]=0;
	    A_[D+M+idx][idx]=1;
	    A_[D+idx][idx]=-1;
	    b[idx]=1;
	    idx++;
	  }
	for(int row=0;row<D+M;row++)
	  {
	    c[row]=0;
	    x[row]=0;
	    nonbasis[row]=row;
	  }
	for(int row=0;row<M;row++)
	  {
	    c[D+M+row]=1;
	    x[D+M+row]=1;
	    basis[row]=D+M+row;
	  }
              	
       	ret=Rsimp(M,D+2*M,A,b,c,x,basis,nonbasis,R,Q,t1,t2);
	
	switch(ret)
	  {
	  case LP_FAIL:
	    fprintf(stderr,"Simplex algorithm fails222!!\n");
	    printf("Simplex algorithm fails222!!\n");
	    //  return 0;
	    //  return 1;
	    //  break;
	  case LP_UNBD:
	    //  break;
	  case LP_OPT:
	    int f=1;
	    for(int k=0;k<M;k++)if(basis[k]>=M+D)
	      {
		//if(x[basis[k]]>0.001)
		f=0;
		break;
	      }
	    if(f==0)
	      {
		return 0;
	      }
	    break;
	  }
      }
      return 1;
}

static inline bool subsettest(const gbasis &g, gbasis::const_iterator i)
{
  if(1)
    {
      //subset test

      for(int a=0;a<(*i).size();a++)
	{
	  bool ok=false;
	  if((*i)[a]>0)
	    {
	      gbasis::const_iterator b;
	      for(b=g.begin();b!=g.end();b++)
		if(b!=i)
		  if((*b)[a]>0)
		    {
		      ok=true;
		      break;
		    }
	    }
	  else
	    if((*i)[a]<0)
	      {
		gbasis::const_iterator b;
		for(b=g.begin();b!=g.end();b++)
		  if(b!=i)
		    if((*b)[a]<0)
		      {
			ok=true;
		      break;
		      }
	      }
	    else ok=true;
	  if(!ok)
	    {

	      if(0)
	      {
		gbasis G=g;
		printf("Skipping simplex with input:\n\n");
		printmatrix(G);
		print(*i);
	      }

	      return true;
	    }
	}
    }
  return false;
}


/* gammel fra for 16.april
 */
static int isirredundant_old(const gbasis &g, gbasis::const_iterator i)
{//returns true if facet binomial


  if(1)
    {
      //subset test

      for(int a=0;a<(*i).size();a++)
	{
	  bool ok=false;
	  if((*i)[a]>0)
	    {
	      gbasis::const_iterator b;
	      for(b=g.begin();b!=g.end();b++)
		if(b!=i)
		  if((*b)[a]>0)
		    {
		      ok=true;
		      break;
		    }
	    }
	  else
	    if((*i)[a]<0)
	      {
		gbasis::const_iterator b;
		for(b=g.begin();b!=g.end();b++)
		  if(b!=i)
		    if((*b)[a]<0)
		      {
			ok=true;
		      break;
		      }
	      }
	    else ok=true;
	  if(!ok)
	    {

	      if(0)
	      {
		gbasis G=g;
		printf("Skipping simplex with input:\n\n");
		printmatrix(G);
		print(*i);
	      }

	      return true;
	    }
	}
    }

  if(0)
    {
      gbasis G=g;
      printf("isirredundant called:\n\n");
      printmatrix(G);
      print(*i);
    }


      bool found1,found=false;
      {
	#define M 40
	#define N 1000
	int ret;
	int n,m;
	static double A_[N][M];
	static double *A[N];
	static double R_[N][M];
	static double *R[N];
	static double Q_[N][M];
	static double *Q[N];
	static double b[M];
	static double c[N];
	static double x[N];
	static int basis[M];
	static int nonbasis[N];
	static double t1[M+N];
	static double t2[M+N];

	// hjde m
	// bredde n
	m=i->size();
	n=m+g.size()-1;

	assert(m<=M);
	assert(n<=N);

	for(int j=0;j<n;j++)A[j]=&(A_[j][0]);
	for(int j=0;j<n;j++)R[j]=&(R_[j][0]);
	for(int j=0;j<n;j++)Q[j]=&(Q_[j][0]);
	int col=0;
	for(gbasis::const_iterator j=g.begin();j!=g.end();j++)
	  {
	    if(i!=j)
	      {
		for(int row=0;row<m;row++)
		  {
		    A_[col][row]=j->v[row];
		  }
		c[col]=0;
		x[col]=0;
		nonbasis[col]=col;
		col++;
	      }
	  }
	for(;col<n;col++)
	  {
	    for(int row=0;row<m;row++)//rettet den 10.april 2002
	      //	    for(int row=0;row<n;row++)
	      A_[col][row]=row==(col-n+m);
	    c[col]=1;
	    x[col]=i->v[col-n+m];
	    if(x[col]<0)
	      {
		x[col]*=-1;
		A_[col][col-n+m]*=-1;
	      }
	    basis[col-n+m]=col;
	  }
	for(int row=0;row<m;row++)
	  {
	    b[row]=i->v[row];
	  }
	  
       	
       	ret=Rsimp(m,n,A,b,c,x,basis,nonbasis,R,Q,t1,t2);
	
	switch(ret)
	  {
	  case LP_FAIL:
	    fprintf(stderr,"Simplex algorithm fails!!\n");
            lp_status=1;

	    if(1)
	      {
		gbasis G=g;
		printf("with input:\n\n");
		printmatrix(G);
		print(*i);
		printf("x[b[]]:");
		for(int k=0;k<m;k++)
		  {
		    printf("%i %f\n\n",basis[k],x[basis[k]]);
		  } 
		fprintf(stderr,"Trying second simplex method\n");
		printf("Trying second simplex method\n");
		bool r=isirredundant_huberthomas(g,i);
		fflush(stdout);
		return r;
	      }

	    return 0;
	    return 1;
	    break;
	  case LP_UNBD:
	    break;
	  case LP_OPT:
	    int f=1;
	    for(int k=0;k<m;k++)if(basis[k]>=n-m)if(x[basis[k]]>0.001)f=0;
	    if(f==0)
	      {
		return 1;
	      }
	    break;
	  }
      }
      return 0;
}




#ifdef SOPLEX
/** Here comes a simple derived class from #SoPlex, which uses #terminate() as
 *  callback method for outputting statistics.
 */
class MySoPlex : public SPxSolver
{
private:
   SLUFactor m_slu;

public:
   /// default constructor
   MySoPlex(Type p_type = LEAVE, Representation p_rep = COLUMN)
      : SPxSolver(p_type, p_rep)
   {



   bool                   print_solution = false;
   bool                   print_quality  = false;
   NameSet                rownames;
   NameSet                colnames;
   SPxStarter*            starter        = 0;
   SoPlex::Type           type           = SoPlex::LEAVE;
   SoPlex::Representation representation = SoPlex::COLUMN;
   int                    precision;
   Real                   delta          = DEFAULT_BND_VIOL;
   Real                   epsilon        = DEFAULT_EPS_ZERO;
   int                    verbose        = 0;
   SLUFactor::UpdateType  update         = SLUFactor::FOREST_TOMLIN;
   Real                   timelimit      = 1.0;-1.0;
   SPxPricer*             pricer         = 0;
   SPxRatioTester*        ratiotester    = 0;
   SPxScaler*             scaler         = 0;
   SPxSimplifier*         simplifier     = 0;

   precision = int(-log10(delta)) + 1;

   Param::setEpsilon(epsilon);
   Param::setVerbose(verbose);



   //options -p4 -t2 -g1 -s0 -c0
   setUtype(update);
   setTerminationTime(timelimit);
   setDelta(delta);

   assert(isConsistent());

   pricer = new SPxSteepPR;
   setPricer(pricer);
   assert(isConsistent());

   ratiotester = new SPxFastRT;
   setTester(ratiotester);
   assert(isConsistent());

   /*   scaler = new SPxEquili(representation == SoPlex::COLUMN, true);
   setScaler(scaler);
   assert(isConsistent());
   */
   setSimplifier(simplifier);
   assert(isConsistent());

   setStarter(starter);
   assert(isConsistent());
   }

   virtual bool terminate()
   {
      /*      if (iteration() % 100 == 0)
         std::cout << iteration() << ":\t" << value() << std::endl;
      */
      return SoPlex::terminate();
   }

   void setUtype(SLUFactor::UpdateType tp)
   {
      m_slu.setUtype(tp);
   }

   void displayQuality()
   {
      double maxviol;
      double sumviol;

      std::cout << "Violations (max/sum)" << std::endl;
                
      qualConstraintViolation(maxviol, sumviol);

      std::cout << "Constraints      :" 
                << std::setw(16) << maxviol << "  " 
                << std::setw(16) << sumviol << std::endl;

      qualConstraintViolationUnscaled(maxviol, sumviol);

      std::cout << "      (unscaled) :" 
                << std::setw(16) << maxviol << "  " 
                << std::setw(16) << sumviol << std::endl;

      qualBoundViolation(maxviol, sumviol);

      std::cout << "Bounds           :" 
                << std::setw(16) << maxviol << "  " 
                << std::setw(16) << sumviol << std::endl;

      qualBoundViolationUnscaled(maxviol, sumviol);

      std::cout << "      (unscaled) :" 
                << std::setw(16) << maxviol << "  " 
                << std::setw(16) << sumviol << std::endl;

      qualSlackViolation(maxviol, sumviol);

      std::cout << "Slacks           :" 
                << std::setw(16) << maxviol << "  " 
                << std::setw(16) << sumviol << std::endl;

      // qualRdCostViolation(maxviol, sumviol);

      //std::cout << "Reduced costs    :" 
      //          << std::setw(16) << maxviol << "  " 
      //          << std::setw(16) << sumviol << std::endl;
   }


   void build(const gbasis &g, gbasis::const_iterator i, SPxScaler *scaler)
   {
      unInit();
      clear();
      
      int width=g.size()-1;
      int height=i->v.size();

      LPColSet cols(width,width*height);
      DSVector c1(height);

      //Build Cols
      for(gbasis::const_iterator j=g.begin();j!=g.end();j++)
         {
            c1.clear();
            for(int t=0;t<height;t++)
               if(j->v[t]!=0)
                  c1.add(t,(double)(j->v[t]));
            
            if(j!=i)
               {
                  Real obj=0;
                  Real upper=infinity;
                  Real lower=0;

                  cols.add(obj,lower,c1,upper);
               }
         }


      LPRowSet rows(height,width*height);
      DSVector r1(width);

      //Change Rows
      for(int t=0;t<height;t++)
         {
            rows.add(i->v[t],r1,i->v[t]);
         }

      addRows(rows);
      addCols(cols);
      /*
      //Build Cols
      for(gbasis::const_iterator j=g.begin();j!=g.end();j++)
         if(j!=i)
            {
               c1.clear();
               for(int t=0;t<height;t++)
                  if(j->v[t]!=0)
                     c1.add(t,(double)(j->v[t]));
            }
      */

      changeSense(SPxLP::MINIMIZE);

      setScaler(scaler);
      assert(isConsistent());
   }

   void buildold(const gbasis &g, gbasis::const_iterator i)
   {
      clear();
      
      int width=g.size()-1;
      int height=i->v.size();

      LPColSet cols(width,width*height);
      DSVector c1(height);

      //Build Cols
      for(gbasis::const_iterator j=g.begin();j!=g.end();j++)
         {
            c1.clear();
            for(int t=0;t<height;t++)
               if(j->v[t]!=0)
                  c1.add(t,(double)(j->v[t]));

            if(j!=i)
               {
                  Real obj=0;
                  Real upper=infinity;
                  Real lower=0;

                  cols.add(obj,lower,c1,upper);
               }
         }
      addCols(cols);

      //Change Rows
      for(int t=0;t<height;t++)
         {
            LPRow R;
            if(t>=nRows())
               {
                  addRow(R);
               }
            getRow(t,R);
            R.setRhs(i->v[t]);
            R.setLhs(i->v[t]);
            R.setType(LPRow::EQUAL);
            changeRow(t,R);
         }

      changeSense(SPxLP::MINIMIZE);
   }
};

static int toint(float r)
{
   return *((int*)&r);
}

static void printLP(SPxLP &w)
{
      std::cout << "LP has " 
             << w.nRows() 
             << "\trows and\n       "
             << w.nCols() 
             << "\tcolumns" 
             << std::endl;
      int nr=w.nRows();
      int nc=w.nCols();

      for(int i=0;i<nr;i++)
         {      
            for(int j=0;j<nc;j++)
               {
                  LPRow R;
                  w.getRow(i,R);
                  //  if(j<R.rowVector().size())
                     std::cout<<R.rowVector()[j]<<" ";
                  //  else
                     //                     std::cout<<(0.0)<<" ";
               }
            std::cout<<std::endl;
         }
      std::cout<<std::endl;

      for(int i=0;i<nr;i++)
         {      
            for(int j=0;j<nc;j++)
               {
                  LPCol C;
                  w.getCol(j,C);
                  //                  if(i<C.colVector().size())
                     std::cout<<C.colVector()[i]<<" ";
                     // else
                     // std::cout<<(0.0)<<" ";
               }
            std::cout<<std::endl;
         }

      std::cout<<"cols:"<<std::endl;

      for(int j=0;j<nc;j++)
         {
            LPCol C;
            w.getCol(j,C);
            std::cout<<C.lower()<<" "<<C.upper()<<" "<<C.obj()<<std::endl;
            std::cout<<toint(C.lower())<<" "<<toint(C.upper())<<" "<<toint(C.obj())<<std::endl;
         }

      std::cout<<"rows:"<<std::endl;

      for(int i=0;i<nr;i++)
         {
            LPRow R;
            w.getRow(i,R);
            std::cout<<toint(R.lhs())<<" "<<toint(R.rhs())<<" "<<R.type()<<std::endl;
         }
}


MySoPlex work(SoPlex::LEAVE, SoPlex::COLUMN);
#endif

//int isirredundant(const gbasis &g, gbasis::const_iterator i)
int isfacet(const gbasis &g, gbasis::const_iterator i)
{
   if(option_facetsubset)
      if(subsettest(g,i))return true;
#ifdef SOPLEX
   if(!option_facetsoplex)
#endif
      return isirredundant_old(g,i);
#ifdef SOPLEX
   SoPlex::Type           type           = SoPlex::LEAVE;
   SoPlex::Representation representation = SoPlex::COLUMN;
   SPxEquili scaler(representation == SoPlex::COLUMN, true);

   //   return isirredundant_old(g,i);


   //   std::cerr<<"constructing lp\n";

      /*   for(gbasis::const_iterator j=g.begin();j!=g.end();j++)
           {
           if(j==i)std::cout<<("#");
           print(*j);
           }
      */



   //      MySoPlex work(type, representation);

   work.clear();
   //  work.unInit();

   /*   MySoPlex work2;
   work2.build(g,i);
   work.loadLP(work2);
   */

   //   for(int t=0;t<10;t++)

   //   scaler = new 
   //   setScaler(scaler);
   //   assert(isConsistent());
  


   work.build(g,i,&scaler);


   work.init();

   //   Timer timer;


   // timer.start();
 retry:
   work.solve();

   //   std::cerr<<"done solving"<<std::endl;

   //   timer.stop();

   SoPlex::Status stat = work.status();

   //   if(scaler)delete scaler;
   switch (stat)
   {
   case SoPlex::OPTIMAL:
      /*      std::cout << "solution value is: "
                << std::setprecision(precision)
                << work.value()
                << std::endl;

      */
      /*      if (print_quality)
         work.displayQuality();

      if (print_solution)
      {
         if (simplifier != 0)
         {
            std::cerr 
               << "Output of solution vector with simplifier not implemented"
               << " (use -s0 switch)."
               << std::endl;
         }      
         else
         {
            DVector objx(work.nCols());
            
            work.getPrimalUnscaled(objx);
            
            for(int i = 0; i < work.nCols(); i++)
               if (isNotZero(objx[i], epsilon))
                  std::cout << colnames[work.cId(i)] << "\t" 
                            << std::setw(16)
                            << std::setprecision(precision)
                            << objx[i] << std::endl;
            std::cout << "All other variable are zero." << std::endl;
         }
      }
      */
      break;
   case SoPlex::UNBOUNDED:
      std::cout << "LP is unbounded";
      lp_status=1;
      break;
   case SoPlex::INFEASIBLE:
      //      std::cout << "LP is infeasible";
      break;
   case SoPlex::ABORT_TIME:
      std::cout << "aborted due to time limit";
      lp_status=1;

      for(int t=0;t<1;t++)
         {
            {
               std::ofstream s("temptemp");

               //  work.build(g,i);
               //  work.writeMPS(s,0,0);
            }
      {
         std::ifstream s("temptemp");
         work.readMPS(s,0,0);
      }
      //      work.reLoad();
      std::cout << "LP has " 
             << work.nRows() 
             << "\trows and\n       "
             << work.nCols() 
             << "\tcolumns" 
             << std::endl;
      work.writeMPS(std::cerr,0,0);


      //      printLP(work);
      //    work.solve();
      goto retry;
         }
      if(work.status()==SoPlex::ABORT_TIME)std::cerr <<"timeabort";
      assert(0);
      break;
   case SoPlex::ABORT_ITER:
      std::cout << "aborted due to iteration limit";
      lp_status=1;
      break;
   case SoPlex::ABORT_VALUE:
      std::cout << "aborted due to objective value limit";
      lp_status=1;
      break;
   default:
      std::cout << "An error occurred during the solution process";
      lp_status=1;
      break;
   }

   /*   if (scaler != 0)
      delete scaler;
   if (simplifier != 0)
      delete simplifier;
   if (starter != 0)
      delete starter;

   assert(pricer != 0);
   delete pricer;

   assert(ratiotester != 0);
   delete ratiotester;
   */
   /*   if (basisname != 0)
      delete [] basisname;
   */
if(stat==SoPlex::INFEASIBLE)
{
   return true;
}
return false;
#endif
}

//-----------------------------------------------------------------------------
//Emacs Local Variables:
//Emacs mode:c++
//Emacs c-basic-offset:3
//Emacs tab-width:8
//Emacs indent-tabs-mode:nil
//Emacs End:
//-----------------------------------------------------------------------------
