#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <list>

using namespace std;

#include "vektor.h"
#include "LLL.h"
#include "print.h"
#include "division.h"
#include "buchberger.h"
#include "toric.h"
#include "flip.h"

#include "testresult.h"

extern int numberofvektors;

basis_i readmatrix()
{
  int rows,cols,max;

  basis_i B;

  /*  basis_i B=tobasis_i("{(1,2,3,4)"
		      " (2,3,4,1)"
		      " (3,4,1,2)"
		      " (4,1,2,3)"
		      " (0,1,4,5)"
		      " (1,4,5,0)"
		      " (4,5,0,1)"
		      " (5,0,1,4)}");
  */

  /*  basis_i B=tobasis_i("{(1,2,3)"
		      " (2,3,4)"
		      " (3,4,1)"
		      " (1,4,5)"
		      " (4,5,0)"
		      " (5,0,1)}");
  */
  fprintf(stderr,"rows?(0 for non-random matrix)");
  scanf("%i",&rows);
 
  if(rows>0)
    {
      fprintf(stderr,"cols?");
      scanf("%i",&cols);
      fprintf(stderr,"max?");
      scanf("%i",&max);

      B=randommatrix_i(rows,cols,max);
    }
  else
    {
      char matrix[40*40*4];
      fprintf(stderr,"type in ascii representation:");
      scanf("%s",matrix);
      B=tobasis_i(matrix);
    }

  /*     basis_i B=tobasis_i("{(2,0,0)"
			 "(1,1,0)"
			 "(0,2,0)"
			 "(1,0,1)"
			 "(0,1,1)"
			 "(0,0,2)}");
  */

  /*     basis_i B=tobasis_i("{(3)"
			 "(4)"
			 "(5)}");
  */

  return B;
}

void test0()
{
  int rows,cols,max;

  /*      basis_i B=tobasis_i("{(1,2,3,4)"
			" (2,3,4,1)"
			" (3,4,1,2)"
			" (4,1,2,3)"
			" (0,1,4,5)"
			" (1,4,5,0)"
			" (4,5,0,1)"
			" (5,0,1,4)}");
  */ 
  basis_i B=readmatrix();
      
  print_timebegin();

  //  print_alfabeta();
  
  gbasis g=toric_simple(B);
  
  testresult t=testresult_new();
  t.time=print_gettime();
  t.size_lex=g.size();
  testresult_write(t);
}
/*
  fprintf(stderr," 1) Compute Grobner basis with respect to lexicographic ordering  using Algorithm 1\n");
  fprintf(stderr," 2) Same as 1) but using an other elimination term order\n");
  fprintf(stderr," 3) Compute Grobner basis with respect to graded reverse lexicographic ordering  using Algorithm 2\n");
  fprintf(stderr," 4) Same as 2) but without LLL reducing the lattice kernel\n");
  fprintf(stderr," 5) Use 3) and Buchberger to produce lexicographic Grobner basis\n");
  fprintf(stderr," 6) Use 3) and Grobner walk to produce lexicographic Grobner basis\n");
  fprintf(stderr," 7) Compute the Grobner fan using exhaustive search method\n");
  fprintf(stderr," 8) Compute the Grobner fan using reverse search method\n");
  fprintf(stderr," 9) Compute the Grobner fan using oriented exhaustive search method\n");
  fprintf(stderr,"10) Compute the Grobner fan using hybrid algorithm\n");
*/
void test1()
{
  //computing a grobner basis for I_A
  basis_i B=readmatrix();

  print_timebegin();
  print_alfabeta();
  
  gbasis g=toric_simple(B);
  printf("\n");

  //  printt(g);
  
  testresult t=testresult_new();
  t.time=print_gettime();
  t.size_lex=g.size();
  t.dim_d=B[0].size();
  t.dim_n=B.size();
  t.kerdim=toric1_kerdim;
  testresult_write(t);
}

void test2()
{
  //computing a grobner basis for I_A
  basis_i B=readmatrix();

  print_timebegin();
  print_alfabeta();
  
  usemixedelim=true;
  gbasis g=toric_simple(B);
  printf("\n");

  //  printt(g);
  
  testresult t=testresult_new();
  t.time=print_gettime();
  t.size_grevlex=g.size();
  t.dim_d=B[0].size();
  t.dim_n=B.size();
  t.kerdim=toric1_kerdim;
  testresult_write(t);
}

void test3()
{
  //computing a grobner basis for I_A
  basis_i B=readmatrix();

  print_timebegin();
  print_alfabeta();
  
  gbasis g=toric1(B);
  printf("\n");

  //  printt(g);
  
  testresult t=testresult_new();
  t.time=print_gettime();
  t.size_grevlex=g.size();
  t.dim_d=B[0].size();
  t.dim_n=B.size();
  t.kerdim=toric1_kerdim;
  testresult_write(t);
}

void test4()
{
  //computing a grobner basis for I_A
  basis_i B=readmatrix();

  print_timebegin();
  print_alfabeta();
  
  //do not LLL reduce!!!
  uselll=0;
  gbasis g=toric1(B);
  printf("\n");

  printt(g);
  
  testresult t=testresult_new();
  t.time=print_gettime();
  t.size_grevlex=g.size();
  t.dim_d=B[0].size();
  t.dim_n=B.size();
  t.kerdim=toric1_kerdim;
  testresult_write(t);
}

void test5()
{
  testresult t=testresult_new();
  //computing a grobner basis for I_A with respect to the lexicographic term order using Buchberger's Algorithm
  basis_i B=readmatrix();

  print_timebegin();
  print_alfabeta();
  
  gbasis g=toric1(B);
  vektor_i::TERMORDER=LEXICOGRAPHIC;
  vektor_i::setcheapest(0);

  t.size_grevlex=g.size();

  buchberger(g);
  
  gbasissort(&g);
  gbasisminimal(&g);
  gbasisautoreduction(&g);

  printf("\n");

  printf("\\newpage\n");

  printt(g);
  
  t.time=print_gettime();
  t.size_lex=g.size();
  testresult_write(t);
}

void test6()
{
  testresult t=testresult_new();
  //computing a grobner basis for I_A with respect to the lexicographic term order using the Gr\"obner Walk
  basis_i B=readmatrix();

  print_timebegin();
  print_alfabeta();
  
  gbasis g=toric1(B);
  vektor_i::TERMORDER=LEXICOGRAPHIC;
  vektor_i::setcheapest(0);


  printf("Doing the Gr\\\"obner Walk.....\n\n");
  t.size_grevlex=g.size();
  g=walk(g);
  t.size_lex=g.size();

  printf("\n");

  printf("Gr\\\"obner basis for $I_A$ with respect to the lexicographic term order:\n\n");

  gbasissort(&g);

  printf("\\newpage\n");

  printt(g);
  
  t.time=print_gettime();
  testresult_write(t);
}

//Traverse the Grobner fan using ES
void test7()
{
  //computing a grobner basis for I_A
  basis_i B=readmatrix();

  print_timebegin();
  print_alfabeta();
  
  gbasis g=toric1(B);
  printf("\n");

  //  printt(g);

  fflush(stdout);

  //  vektor_i::TERMORDER=LEXICOGRAPHIC;
  //  vektor_i::setcheapest(0);
  
  printf("\n\nComputing the Gr\\\"obner fan using exhaustive search...\n\n");

  computegrobnerfan(g);

  printf("\n\nThe state polytope consists of %i vertices.\n\n",computegrobnerfan_size,computegrobnerfan_nedges);

  testresult t=testresult_new();
  t.time=print_gettime();
  t.size_gfan=computegrobnerfan_size;
  testresult_write(t);
}

//Traverse the Grobner fan using RS
void test8()
{
  //computing a grobner basis for I_A
  basis_i B=readmatrix();

  print_timebegin();
  print_alfabeta();
  
  gbasis g=toric1(B);
  printf("\n");

  //  printt(g);

  fflush(stdout);

  //  vektor_i::TERMORDER=LEXICOGRAPHIC;
  //  vektor_i::setcheapest(0);

  printf("\n\nComputing the Gr\\\"obner fan using the reverse search method...\n\n");
  
  computegrobnerfan_rs(g);

  printf("\n\nThe state polytope consists of %i vertices and %i edges.\n\n",computegrobnerfan_size,computegrobnerfan_nedges);

  testresult t=testresult_new();
  t.time=print_gettime();
  t.size_gfan=computegrobnerfan_size;
  t.nedges_gfan=computegrobnerfan_nedges;
  t.dim_d=B[0].size();
  t.dim_n=B.size();
  t.kerdim=toric1_kerdim;
  testresult_write(t);
}

void test9()
{
  //computing a grobner basis for I_A
  basis_i B=readmatrix();

  print_timebegin();
  print_alfabeta();
  
  gbasis g=toric1(B);
  printf("\n");

  //  printt(g);

  fflush(stdout);

  printf("\n\nComputing the Gr\\\"obner fan using a faster exhaustive search...\n\n");

  //  vektor_i::TERMORDER=LEXICOGRAPHIC;
  //  vektor_i::setcheapest(0);
  
  useordered=true;
  computegrobnerfan(g);

  printf("\n\nThe state polytope consists of %i vertices.\n\n",computegrobnerfan_size);

  testresult t=testresult_new();
  t.time=print_gettime();
  t.size_gfan=computegrobnerfan_size;
  testresult_write(t);
}

//Traverse the Grobner fan using hybrid algorithm
void test10()
{
  //computing a grobner basis for I_A
  basis_i B=readmatrix();

  print_timebegin();
  print_alfabeta();
  
  gbasis g=toric1(B);
  printf("\n");

  //  printt(g);

  fflush(stdout);

  //  vektor_i::TERMORDER=LEXICOGRAPHIC;
  //  vektor_i::setcheapest(0);
  
  printf("\n\nComputing the Gr\\\"obner fan using a hybrid algorithm...\n\n");

  computegrobnerfan_hb(g);

  printf("\n\nThe state polytope consists of %i vertices.\n\n",computegrobnerfan_size);

  testresult t=testresult_new();
  t.time=print_gettime();
  t.size_gfan=computegrobnerfan_size;
  testresult_write(t);
}

