
typedef struct testresult
{
  int time;
  int dim_d;
  int dim_n;
  int kerdim;
  int size_grevlex;
  int size_lex;
  int steps;
  int size_gfan;
  int nedges_gfan;
  int floatingpointstatus;
} testresult;

testresult testresult_read(char *filename="output")
{
  char buf[256];
  FILE *f;
  testresult t;

  f=fopen(filename,"r");
  fscanf(f,"%s %i",buf,&t.time);
  fscanf(f,"%s %i",buf,&t.dim_d);
  fscanf(f,"%s %i",buf,&t.dim_n);
  fscanf(f,"%s %i",buf,&t.kerdim);
  fscanf(f,"%s %i",buf,&t.size_grevlex);
  fscanf(f,"%s %i",buf,&t.size_lex);
  fscanf(f,"%s %i",buf,&t.steps);
  fscanf(f,"%s %i",buf,&t.size_gfan);
  fscanf(f,"%s %i",buf,&t.nedges_gfan);
  fscanf(f,"%s %i",buf,&t.floatingpointstatus);

  fclose(f);

  return t;
}

testresult testresult_new()
{
  testresult t;

  t.time=-1;
  t.dim_d=-1;
  t.dim_n=-1;
  t.kerdim=-1;
  t.size_grevlex=-1;
  t.size_lex=-1;
  t.steps=-1;
  t.size_gfan=-1;
  t.nedges_gfan=-1;

  return t;
}

void testresult_write(testresult t, char *filename="output")
{
  FILE *f;

  f=fopen(filename,"w");
  fprintf(f,"Time:                              %i\n",t.time);
  fprintf(f,"Dimension:                         %i\n",t.dim_d);
  fprintf(f,"Dimension:                         %i\n",t.dim_n);
  fprintf(f,"Dimension:                         %i\n",t.kerdim);
  fprintf(f,"GRlex_gbasis_size:                 %i\n",t.size_grevlex);
  fprintf(f,"Lex_gbasis_size:                   %i\n",t.size_lex);
  fprintf(f,"Steps?:                            %i\n",t.steps);
  fprintf(f,"Graph_vertices:                    %i\n",t.size_gfan);
  fprintf(f,"Graph_edges:                       %i\n",t.nedges_gfan);
  fprintf(f,"Floating_point_status_(0_=_ok):    %i\n",t.floatingpointstatus);

  fclose(f);
}

